# coding=utf-8
from django.conf import settings
from django.shortcuts import redirect, render

from ..auth import do_login, do_logout

login_url = getattr(settings, "LOGIN_URL")


"""
    !!! WARNING !!!
    This is probably dead code - because login is handled by `django-two-factor-auth`
"""
def login(request):
    context = {
        'state': 'initial',
    }
    if request.GET and request.GET.get('error'):
        context['state'] = request.GET.get('error')

    if request.method == "GET" and request.GET:
        context['next'] = request.GET.get('next')

    if request.method == "POST" and request.POST:
        state, message = do_login(request)
        if state:
            if request.POST.get('next'):
                return redirect(request.POST.get('next'))
                # FIXME: risk of phishing attacks
                #  see https://www.owasp.org/index.php/Unvalidated_Redirects_and_Forwards_Cheat_Sheet
            else:
                return redirect(login_url)
        else:
            response = redirect(login_url)
            response['Location'] += "?error={}".format(message)
            return response
    return render(request, "login.html", context)

def logout(request):
    _, message = do_logout(request)
    response = redirect(login_url)
    response['Location'] += "?error={}".format(message)
    return response
